
/**
 * Write a description of class Demonstration here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Demo {

    public static void main(String[] args){
        
        Circuit c1 = new CircuitImpl(16);
        
        ElectricDevice e1 = new ElectricDevice("vysavac ETA Hoocot", 230, 1000);
        ElectricDevice e2 = new ElectricDevice("pracka Tatramat Skokan", 230, 1200);
        ElectricDevice e3 = new ElectricDevice("trouba Morak Sp23", 230, 1400);
        ElectricDevice e4 = new ElectricDevice("mycka Miele Zacht", 230, 800);
        ElectricDevice e5 = new ElectricDevice("zarovka Osram Blique", 230, 60);
        ElectricDevice e6 = new ElectricDevice("PC MoMane Crzap", 230, 120);
        ElectricDevice e7 = new ElectricDevice("stara zarovka Tehla Mjowr", 230, 100);

        try {
            System.out.print("Zapojuji mnoho vypnutych zarizeni...            \t");
            e1.plug(c1);
            e2.plug(c1);
            e3.plug(c1);
            e4.plug(c1);
            e5.plug(c1);
            ((CircuitImpl)c1).printDevices();
            System.out.println("OK");
        } catch (CircuitOverloadException ex) {
            System.out.println("ERROR: vypnuta zarizeni nemaji generovat pretizeni site");
            return;
        }

        try {
            System.out.print("Zapinam nektera zarizeni...                     \t");
            e1.switchOn();
            e2.switchOn();
            e3.switchOn();
            e5.switchOn();
            System.out.println("OK");
        } catch(CircuitOverloadException ex) {
            System.out.println("ERROR: zarizeni nemaji dostatecny odber, presto vyhodila jistic");
            return;
        }

        System.out.print("Vypinam jedno zarizeni...                       \t");
        e5.switchOff();
        System.out.println("OK");

        try {
            System.out.print("Odpojuji vypnute zarizeni ze site...            \t");
            e5.unplug();
            System.out.println("OK");
        } catch(Exception ex) {
            System.out.println("ERROR: byla vyhozena neocekavana vyjimka: " + ex);
            return;
        }

        try {
            System.out.print("Odpojuji zapnute zarizeni ze site...            \t");
            e2.unplug();
            System.out.println("OK");
        } catch(Exception ex) {
            System.out.println("ERROR: byla vyhozen neocekavana vyjimka: " + ex);
            return;
        }

        try {
            System.out.print("Zkousim odpojit zarizeni, ktere neni v siti...  \t");
            e5.unplug();
            e7.unplug();
            System.out.println("ERROR: nebyla vyhozena pozadovana vyjimka");
            return;
        } catch(UnsupportedOperationException ex) {
            System.out.println("OK");
        }
        
        try {
            System.out.print("Zapinam zarizeni, ktera je pripojeno do zasuvky...\t");
            e4.switchOn();
            System.out.println("OK");
        } catch(Exception ex) {
            System.out.println("ERROR: zarizeni nemaji dostatecny odber, presto vyhodila jistic");
            return;
        }

        try {
            System.out.print("Zapinam zarizeni, ktera nejsou pripojena do zasuvku...\t");
            e5.switchOn();
            e2.switchOn();
            System.out.println("OK");
        } catch(Exception ex) {
            System.out.println("ERROR: byla vyhozena neocekavana vyjimka");
            return;
        }

        try {
            System.out.print("Pridavam zapnute zarizeni...                    \t");
            e5.plug(c1);
            System.out.println("OK");
        } catch(CircuitOverloadException ex) {
            System.out.println("ERROR: zarizeni chybne vyhodilo jistic");
            return;
        }

        try {
            System.out.print("Pridavam dalsi zapnute zarizeni...               \t");
            e2.plug(c1);
            System.out.println("ERROR: toto zarizeni jiz melo vyhodit jistic");
            return;
        } catch(CircuitOverloadException ex) {
            System.out.println("OK");
        }
        
        try {
            System.out.print("Zkousim nahodit jistic...                        \t");
            c1.restoreCurrent();
            System.out.println("ERROR: jistic mel vypadnout");
            return;
        } catch(CircuitOverloadException ex) {
            System.out.println("OK");
        }
        
        System.out.print("Vypinam jedno zarizeni...                        \t");
        e2.switchOff();
        System.out.println("OK");
        
        try {
            System.out.print("Zkousim znovu nahodit jistic...                 \t");
            c1.restoreCurrent();
            System.out.println("OK");
        } catch(CircuitOverloadException ex) {
            System.out.println("ERROR: jistic mel vypadnout");
            return;
        }
    }    
}
